#!/usr/bin/env python
#title:		cnn_processing.py
#description:	The script creates a Sqlite database and starts the cnn_process_directory function to perform the Objective Text extraction.
#author:	A. Ortis
#date:		20170925
#version:		0.1
#usage:		change the values of the CNN model and the 'dbname' 
#notes:		
#==============================================================================
from cnn_processing import cnn_process_directory
import sqlite3 as lite
import sys

# Change the dbname
dbname = "GoogleNetcnnData.db"
con = lite.connect(dbname)

with con:
    
    cur = con.cursor()    
    cur.execute("DROP TABLE IF EXISTS Cnndata")
    cur.execute("CREATE TABLE Cnndata(Id INTEGER PRIMARY KEY, FlickrId TEXT, Cnn TEXT, fc7 TEXT, top_3_labels TEXT, top_3_probs TEXT)")
con.close()

# Change the CNN model name
cnn_process_directory("googlenet", "/home/SentimentAnalysis/flickrCrawling/images",dbname)
