#!/usr/bin/env python
#title:		objectiveWordsReranking.py
#description:	The script edits the senti score triplet for objective words according to Hung and Lin.
#author:	A. Ortis
#date:		20170925
#version:		0.1
#usage:		
#notes:		
#==============================================================================


import json
import pprint
from utils import is_objective, extract_single_senti_scores as sentiTriplet
import nltk, sys

out_json_file = 'DS1_revisitedScores.json'
f = open('DS1_freqVectors.json','r')
freq = json.loads(f.read())
f.close()
f = open('textVoc.json')
V = json.loads(f.read())
f.close()


revisited_scores = []
for i in range(len(V)):
	revisited_scores.append([0,0,0])

# Just statistic variables
P1 =[]
P2 =[]
obj_count = 0
y1 = 0;
y2= 0;
no1 = 0;
no2=0;

for idx, X in enumerate(freq):
	
	w = V[idx]
	p,n,o = sentiTriplet(w)
	revisited_scores[idx] = [p,o,n]

	if not is_objective(w):
		continue

	obj_count += 1
	m = max(X[1],X[2])
	m = float(m)


	d1 = X[0]
	d2 = X[1] + X[2]
	
	if d1>0 and m/d1 >=0.5:
		P1.append(m/d1)
#		print "1) Change sentiment of word\t" + w + "\tfrom\t" + "("+str(p)+","+str(o)+",-"+str(n)+")"

			
 		if X[1]:	#positive 
			new_p = float(m)/d1
			new_n = 0
			new_o = 1 - new_p

		else:		#negative
			new_p = 0
			new_n = float(m)/d1
			new_o = 1- new_n
#		print "to\t" + "("+str(new_p)+","+str(new_o)+",-"+str(new_n)+")"

		if new_o >= 0.5 or X[1] == X[2]:
#			print "NO!"
			no1+=1
		else:
			revisited_scores[idx] = [new_p, new_o, new_n]

#			print "YES!"
			y1+=1
#		_ = raw_input()
		
	if (X[1]+X[2])>0 and m/(X[1]+X[2]) >=0.5:
		P2.append(m/(X[1]+X[2]))
		print m/(X[1]+X[2])
		print "2) Change sentiment of word\t" + w + "\tfrom\t" + "("+str(p)+","+str(o)+",-"+str(n)+")"
 		if m == X[1]:	#positive 
			new_p = float(m)/(X[1]+X[2])
			new_n = 0
			new_o = 1- new_p

		else:		#negative
			new_p = 0
			new_n = float(m)/(X[1]+X[2])
			new_o = 1- new_n
		print "to\t" + "("+str(new_p)+","+str(new_o)+",-"+str(new_n)+")"

#		if new_o > max(new_p,new_n) or X[1] == X[2]:
		if new_o >= 0.5 or X[1] == X[2]:
			print "NO!"
			no2+=1
		else:
			print "YES!"
			y2+=1


print "Tot. words:\t"+ str(len(freq))
print "P1\t" + str(len(P1))
print "P2\t" + str(len(P2))
print "objC\t" + str(obj_count)
print "yes1\t"+ str(y1)
print "yes2\t"+ str(y2)
print len(revisited_scores)
pprint.pprint(revisited_scores)

f = open(out_json_file,'w')
f.write(json.dumps(revisited_scores))
f.close()
